angular.module('tms', ['ionic', 'tms.controllers', 'tms.services', 'tms.filters', 'ngCordova'])
        .run(function ($ionicPlatform) {
            $ionicPlatform.ready(function () {
                if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                    cordova.plugins.Keyboard.disableScroll(true);
                }
                if (window.StatusBar) {
                    StatusBar.styleLightContent();
                }
            });
        })
        .config(function ($stateProvider, $urlRouterProvider) {
            $urlRouterProvider.otherwise('/');
            $stateProvider
                    .state('home', {
                        url: '/',
                        templateUrl: 'templates/logon.html',
                        controller: 'HomeCtrl'
                    })
                    .state('main', {
                        url: '/main',
                        templateUrl: 'templates/main.html',
                        controller: 'MainCtrl'
                    })
                    .state('new', {
                        url: '/new',
                        templateUrl: 'templates/form.html',
                        controller: 'FormCtrl'
                    })
                    .state('report', {
                        url: '/report',
                        templateUrl: 'templates/report.html',
                        controller: 'ReportCtrl'
                    })
                    .state('list', {
                        url: '/list',
                        templateUrl: 'templates/list.html',
                        controller: 'ListCtrl'
                    })
                    .state('listdetail', {
                        url: '/listdetail/:timeId/:status',
                        templateUrl: 'templates/listdetail.html',
                        controller: 'ListDetailCtrl'
                    })
                    .state('formedit', {
                        url: '/formedit/:timeId',
                        templateUrl: 'templates/formedit.html',
                        controller: 'FormEditCtrl'
                    })
                    .state('logout', {
                        url: '/',
                        templateUrl: 'templates/logon.html',
                        controller: 'LogoutCtrl'
                    });
        });
