angular.module('tms.controllers', [])
        .controller('HomeCtrl', function ($scope, tmsService, $ionicPopup, $ionicLoading, $window, $ionicHistory) {
            $window.localStorage['uid'] = "1654364x564sdfsdfrtR?!@323#Sd%";
            $window.localStorage['token'] = null;
            $scope.showAllert = function (msg) {
                $ionicPopup.alert({
                    title: msg.title,
                    template: msg.message,
                    okText: 'Ok',
                    okType: 'button-positive'
                });
            };
            $scope.data = {};
            $scope.login = function () {
                if (!$scope.data.uname) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Driver ID must not null'
                    });
                } else if (!$scope.data.passwd) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Password must not null'
                    });
                } else {
                    var data = {
                        uname: $scope.data.uname,
                        passwd: $scope.data.passwd
                    };
                    $scope.show = function () {
                        $ionicLoading.show({
                            template: 'Signing In...'
                        });
                    };
                    $scope.hide = function () {
                        $ionicLoading.hide();
                    };
                    $scope.show();
                    tmsService.doLogin(data).success(function (resp) {
                        if (resp.status == 1) {
                            $ionicHistory.clearHistory();
                            $ionicHistory.nextViewOptions({
                                disableBack: true
                            });
                            $scope.data.uname = "";
                            $scope.data.passwd = "";
                            $scope.uid = resp.uid;
                            $scope.token = resp.token;
                            $window.localStorage['uid'] = $scope.uid;
                            $window.localStorage['token'] = $scope.token;
                            $window.location.href = '#/main';
                        } else {
                            $scope.showAllert({
                                title: '<i class="icon ion-minus-circled"></i> INVALID LOGIN',
                                message: 'Invalid PIN or Driver ID!'
                            });
                        }
                    }, function (err) {
                        $scope.showAllert({
                            title: '<i class="icon ion-minus-circled"></i> ERROR',
                            message: err
                        });
                    }).finally(function () {
                        $scope.hide();
                    });
                }
            };
        })
        .controller('LogoutCtrl', function ($ionicHistory, $window) {
            $window.localStorage['uid'] = "1654364x564sdfsdfrtR?!@323#Sd%";
            $ionicHistory.clearCache();
            $ionicHistory.clearHistory();
            $ionicHistory.nextViewOptions({disableBack: true, historyRoot: true});
        })
        .controller('MainCtrl', function ($scope, $ionicHistory, $window) {
            $scope.menus = [
                {id: 'new', label: 'Create New', icon: 'compose'},
                {id: 'list', label: 'Timesheet', icon: 'clock'},
                {id: 'report', label: 'Report', icon: 'pie-graph'}
            ];
            $scope.doLogout = function () {
                $ionicHistory.clearCache();
                $ionicHistory.clearHistory();
                $ionicHistory.nextViewOptions({disableBack: true, historyRoot: true});
                $window.localStorage['token'] = null;
            };
        })
        .controller('FormCtrl', function ($scope, tmsService, $ionicPopup, $ionicLoading, $window, $filter, $cordovaDatePicker) {
            $scope.startDate = function () {
                var options = {
                    date: new Date(),
                    mode: 'date',
                    okText: 'Set',
                    androidTheme: 5
                };
                document.addEventListener("deviceready", function () {
                    $cordovaDatePicker.show(options).then(function (date) {
                        $scope.tms.start_date = date;
                        $scope.label.start_date = $filter('date')(date, 'dd/MM/yyyy');
                    });
                }, false);
            };
            $scope.endDate = function () {
                var options = {
                    date: new Date(),
                    mode: 'date',
                    okText: 'Set',
                    androidTheme: 5
                };
                document.addEventListener("deviceready", function () {
                    $cordovaDatePicker.show(options).then(function (date) {
                        $scope.tms.end_date = date;
                        $scope.label.end_date = $filter('date')(date, 'dd/MM/yyyy');
                    });
                }, false);
            };
            $scope.startTime = function () {
                var options = {
                    date: new Date(),
                    mode: 'time',
                    is24Hour: true,
                    okText: 'Set',
                    androidTheme: 3
                };
                document.addEventListener("deviceready", function () {
                    $cordovaDatePicker.show(options).then(function (date) {
                        $scope.tms.start_time = date;
                        $scope.label.start_time = $filter('date')(date, 'HH:mm');
                    });
                }, false);
            };
            $scope.endTime = function () {
                var options = {
                    date: new Date(),
                    mode: 'time',
                    is24Hour: true,
                    okText: 'Set',
                    androidTheme: 3
                };
                document.addEventListener("deviceready", function () {
                    $cordovaDatePicker.show(options).then(function (date) {
                        $scope.tms.end_time = date;
                        $scope.label.end_time = $filter('date')(date, 'HH:mm');
                    });
                }, false);
            };
            $scope.showAllert = function (msg) {
                $ionicPopup.alert({
                    title: msg.title,
                    template: msg.message,
                    okText: 'Ok',
                    okType: 'button-positive'
                });
            };
            $scope.label = {
                start_date: $filter('date')(new Date(), 'dd/MM/yyyy'),
                start_time: $filter('date')(new Date(), 'HH:mm'),
                end_date: $filter('date')(new Date(), 'dd/MM/yyyy'),
                end_time: $filter('date')(new Date(), 'HH:mm')
            };
            $scope.tms = {
                ot: 'no',
                used_for: 'office',
                start_date: new Date(),
                start_time: new Date(),
                end_date: new Date(),
                end_time: new Date()
            };
            $scope.addTimesheet = function () {
                $scope.fstart_date = $filter('date')($scope.tms.start_date, 'yyyyMMdd');
                $scope.fstart_time = $filter('date')($scope.tms.start_time, 'HHmm');
                $scope.fend_date = $filter('date')($scope.tms.end_date, 'yyyyMMdd');
                $scope.fend_time = $filter('date')($scope.tms.end_time, 'HHmm');
                $scope.fstart_datetime = $scope.fstart_date+''+$scope.fstart_time;
                $scope.fend_datetime = $scope.fend_date+''+$scope.fend_time;
                if (!$scope.tms.start_date) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Start date must not null'
                    });
                } else if (!$scope.tms.start_time) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Start time must not null'
                    });
                } else if (!$scope.tms.end_date) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'End date must not null'
                    });
                } else if (!$scope.tms.end_time) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'End time must not null'
                    });
                } else if (!$scope.tms.ot) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Please select Out of town'
                    });
                } else if (!$scope.tms.used_for) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Please select user for'
                    });
                } else if ($scope.fstart_date > $scope.fend_date) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Please check the date entered'
                    });
                } else if ($scope.fstart_date+$scope.fstart_time > $scope.fend_date+$scope.fend_time) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Please check the time entered'
                    });
                } else if (($scope.fend_datetime - $scope.fstart_datetime) >= 10000) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'More than 24 hours isn\'t allowed'
                    });
                } else {
                    $scope.show = function () {
                        $ionicLoading.show({
                            template: 'Submiting data...'
                        });
                    };
                    $scope.hide = function () {
                        $ionicLoading.hide();
                    };
                    $scope.show();
                    var data = {
                        start_date: $scope.tms.start_date,
                        start_time: $scope.tms.start_time,
                        end_date: $scope.tms.end_date,
                        end_time: $scope.tms.end_time,
                        ot: $scope.tms.ot,
                        town: $scope.tms.town,
                        driver_gs: $scope.tms.driver_gs,
                        used_for: $scope.tms.used_for,
                        created_by: $window.localStorage['uid']
                    };
                    tmsService.add(data).success(function (resp) {
                        if (resp.status == 1) {
                            $scope.showAllert({
                                title: '<i class="icon ion-checkmark-round"></i> SUCCESS',
                                message: 'Data has been successful submited'
                            });
                        } else if (resp.status == 2) {
                            $scope.showAllert({
                                title: '<i class="icon ion-minus-circled"></i> ERROR',
                                message: 'Time is overlapped'
                            });
                        } else if (resp.status == 0) {
                            $scope.showAllert({
                                title: '<i class="icon ion-minus-circled"></i> ERROR',
                                message: 'Error. Data fail to submit'
                            });
                        } else {
                            $scope.showAllert({
                                title: '<i class="icon ion-checkmark-round"></i> SUCCESS',
                                message: 'Data has been successful submited'
                            });
                        }

                        $scope.tms = {
                            ot: 'no',
                            used_for: 'office',
                            driver_gs: '',
                            town: '',
                            start_date: new Date(),
                            start_time: new Date(),
                            end_date: new Date(),
                            end_time: new Date()
                        };

                        $scope.label = {
                            start_date: $filter('date')(new Date(), 'dd/MM/yyyy'),
                            start_time: $filter('date')(new Date(), 'HH:mm'),
                            end_date: $filter('date')(new Date(), 'dd/MM/yyyy'),
                            end_time: $filter('date')(new Date(), 'HH:mm')
                        };
                    }, function (err) {
                        $scope.showAllert({
                            title: '<i class="icon ion-minus-circled"></i> ERROR',
                            message: err
                        });
                    }).finally(function () {
                        $scope.hide();
                    });
                }
            };
        })
        .controller('ReportCtrl', function ($scope, tmsService, $ionicLoading, $ionicPopup, $window, $filter, $cordovaDatePicker) {
            $scope.show = function () {
                $ionicLoading.show({
                    template: 'Retrieve data from server...'
                });
            };
            $scope.hide = function () {
                $ionicLoading.hide();
            };
            $scope.show();
            $scope.tmss = [];
            tmsService.getAllReport().success(function (response) {
                $scope.tmss = response;
            }).finally(function () {
                $scope.hide();
            });
            $scope.doRefresh = function () {
                tmsService.getAllReport().success(function (response) {
                    $scope.tmss = response;
                }).finally(function () {
                    $scope.$broadcast('scroll.refreshComplete');
                });
            };
            $scope.viewDetails = function (id) {
                $window.location.href = "#/listdetail/" + id + "/yes";
            };
            $scope.sfromdate = '';
            $scope.stodate = '';
            $scope.searchReport = function () {                
                $scope.datadate = {};
                $ionicPopup.prompt({
                    template: '<ion-list class="list"><ion-item class="item item-input"><span class="input-label">From Date</span><div class="input-block input-time" ng-click="searchFromDate()">{{sfromdate}}</div><input type="hidden" ng-model="datadate.from_date"></ion-item><ion-item class="item item-input"><span class="input-label">To Date</span><div class="input-block input-time" ng-click="searchToDate()">{{stodate}}</div><input type="hidden" ng-model="datadate.to_date"></ion-item></ion-list>',
                    title: '<i class="icon ion-search"></i> SEARCH TIMESHEET',
                    scope: $scope,
                    buttons: [
                        {text: 'Cancel'},
                        {
                            text: 'Search',
                            type: 'button-positive',
                            onTap: function () {
                                $ionicLoading.show({
                                    template: 'Searching...'
                                });
                                var datadate = {
                                    from: $scope.datadate.from_date,
                                    to: $scope.datadate.to_date,
                                    user_id: $window.localStorage['uid']
                                };
                                tmsService.searchReport(datadate).success(function (srcresp) {
                                    $scope.tmss = srcresp;
                                }, function (err) {
                                    $ionicPopup.alert({
                                        title: '<i class="icon ion-minus-circled"></i> ERROR',
                                        template: err
                                    });
                                }).finally(function () {
                                    $scope.hide();
                                    $scope.sfromdate= '';
                                    $scope.stodate= '';
                                });
                                console.log(datadate);
                            }
                        }
                    ]
                });
            };
            $scope.searchFromDate = function () {
                var options = {
                    date: new Date(),
                    mode: 'date',
                    okText: 'Set',
                    androidTheme: 5
                };
                document.addEventListener("deviceready", function () {
                    $cordovaDatePicker.show(options).then(function (date) {
                        $scope.datadate.from_date = date;
                        $scope.sfromdate = $filter('date')(date, 'dd/MM/yyyy');
                    });
                }, false);
            };
            $scope.searchToDate = function () {
                var options = {
                    date: new Date(),
                    mode: 'date',
                    okText: 'Set',
                    androidTheme: 5
                };
                document.addEventListener("deviceready", function () {
                    $cordovaDatePicker.show(options).then(function (date) {
                        $scope.datadate.to_date = date;
                        $scope.stodate = $filter('date')(date, 'dd/MM/yyyy');
                    });
                }, false);
            };
        })
        .controller('ListCtrl', function ($scope, $ionicActionSheet, tmsService, $ionicLoading, $ionicPopup, $window, $filter, $cordovaDatePicker) {
            $scope.show = function () {
                $ionicLoading.show({
                    template: 'Retrieve data from server...'
                });
            };
            $scope.hide = function () {
                $ionicLoading.hide();
            };
            $scope.show();
            $scope.tmss = [];
            tmsService.getAllTimesheet().success(function (response) {
                $scope.tmss = response;
            }).finally(function () {
                $scope.hide();
            });
            $scope.doRefresh = function () {
                tmsService.getAllTimesheet().success(function (response) {
                    $scope.tmss = response;
                }).finally(function () {
                    $scope.$broadcast('scroll.refreshComplete');
                    $scope.checkIndexs = [];
                    $scope.timeIds = [];
                });
            };
            $scope.timeIds = [];
            $scope.checkIndexs = [];
            $scope.checkIndex = function (timeId, tms) {
                $scope.timeId = timeId;
                $scope.tms = tms;
                if ($scope.checkIndexs.indexOf($scope.tms) === -1) {
                    $scope.checkIndexs.push($scope.tms);
                    $scope.timeIds.push($scope.timeId);
                } else {
                    $scope.checkIndexs.splice($scope.checkIndexs.indexOf($scope.tms), 1);
                    $scope.timeIds.splice($scope.timeIds.indexOf($scope.timeId), 1);
                }
            };
            $scope.removeItem = function (index) {
                angular.forEach($scope.checkIndexs, function (value, index) {
                    var index = $scope.tmss.indexOf(value);
                    $scope.tmss.splice($scope.tmss.indexOf(value), 1);
                });
                $scope.checkIndexs = [];
                $scope.timeIds = [];
            };
            $scope.showOption = function (id, tms) {
                $scope.id = id;
                $scope.tms = tms;                
                $ionicActionSheet.show({
                    titleText: 'Option',
                    buttons: [
                        {text: 'Approve'},
                        {text: 'View Details'},
                        {text: 'Search'},
                        {text: 'Edit'}
                    ],
                    destructiveText: 'Delete',
                    cancelText: 'Cancel',
                    cancel: function () {
                    },
                    buttonClicked: function (index) {
                        if (index == 0) {
                            if ($scope.timeIds.length == 0) {
                                $ionicPopup.alert({
                                    title: '<i class="icon ion-alert"></i> WARNING',
                                    template: 'Please select at least a time'
                                });
                            } else {
                                $scope.datapin = {};
                                $ionicPopup.prompt({
                                    template: '<input class="input-pin" placeholder="Enter Your PIN" type="password" ng-model="datapin.pin">',
                                    title: '<i class="icon ion-alert"></i> CONFIRMATION',
                                    scope: $scope,
                                    buttons: [
                                        {text: 'Cancel'},
                                        {
                                            text: 'Approve',
                                            type: 'button-positive',
                                            onTap: function (e) {
                                                if (!$scope.datapin.pin) {
                                                    e.preventDefault();
                                                } else {
                                                    $ionicLoading.show({
                                                        template: 'Verifying...'
                                                    });
                                                    var data = {
                                                        pwd: $scope.datapin.pin,
                                                        ids: $scope.timeIds
                                                    };
                                                    tmsService.approve(data).success(function (response) {
                                                        if (response.status == 0) {
                                                            $ionicPopup.alert({
                                                                title: '<i class="icon ion-minus-circled"></i> ERROR',
                                                                template: 'Invalid PIN. Please check again!'
                                                            });
                                                        } else if (response.status == 1) {
                                                            $ionicPopup.alert({
                                                                title: '<i class="icon ion-minus-circled"></i> ERROR',
                                                                template: 'You do not have privilege to approve'
                                                            });
                                                        } else if (response.status == 3) {
                                                            $ionicPopup.alert({
                                                                title: '<i class="icon ion-checkmark-round"></i> SUCCESS',
                                                                template: 'Timesheet has been succesful approved'
                                                            });
                                                            $scope.removeItem();
                                                        }
                                                    }, function (err) {
                                                        $ionicPopup.alert({
                                                            title: '<i class="icon ion-minus-circled"></i> ERROR',
                                                            template: err
                                                        });
                                                    }).finally(function () {
                                                        $scope.hide();
                                                    });
                                                }
                                            }
                                        }
                                    ]
                                });
                            }
                            return true;
                        } else if (index == 1) {
                            if ($scope.timeIds.length == 0) {
                                $ionicPopup.alert({
                                    title: '<i class="icon ion-alert"></i> WARNING',
                                    template: 'Please select at least a time'
                                });
                            } else if ($scope.timeIds.length == 1) {
                                $scope.tid = $scope.timeIds[0];
                                $window.location.href = "#/listdetail/" + $scope.tid + "/no";
                            } else {
                                $ionicPopup.alert({
                                    title: '<i class="icon ion-alert"></i> WARNING',
                                    template: 'Please select only a time'
                                });
                            }
                            return true;
                        } else if (index == 2) {
                            $scope.sfromdate = '';
                            $scope.stodate = '';
                            $scope.searchFromDate = function () {
                                var options = {
                                    date: new Date(),
                                    mode: 'date',
                                    okText: 'Set',
                                    androidTheme: 5
                                };
                                document.addEventListener("deviceready", function () {
                                    $cordovaDatePicker.show(options).then(function (date) {
                                        $scope.datadate.from_date = date;
                                        $scope.sfromdate = $filter('date')(date, 'dd/MM/yyyy');
                                    });
                                }, false);
                            };
                            $scope.searchToDate = function () {
                                var options = {
                                    date: new Date(),
                                    mode: 'date',
                                    okText: 'Set',
                                    androidTheme: 5
                                };
                                document.addEventListener("deviceready", function () {
                                    $cordovaDatePicker.show(options).then(function (date) {
                                        $scope.datadate.to_date = date;
                                        $scope.stodate = $filter('date')(date, 'dd/MM/yyyy');
                                    });
                                }, false);
                            };
                            $scope.datadate = {};
                            $ionicPopup.prompt({
                                template: '<ion-list class="list"><ion-item class="item item-input"><span class="input-label">From Date</span><div class="input-block input-time" ng-click="searchFromDate()">{{sfromdate}}</div><input type="hidden" ng-model="datadate.from_date"></ion-item><ion-item class="item item-input"><span class="input-label">To Date</span><div class="input-block input-time" ng-click="searchToDate()">{{stodate}}</div><input type="hidden" ng-model="datadate.to_date"></ion-item></ion-list>',
                                title: '<i class="icon ion-search"></i> SEARCH TIMESHEET',
                                scope: $scope,
                                buttons: [
                                    {text: 'Cancel'},
                                    {
                                        text: 'Search',
                                        type: 'button-positive',
                                        onTap: function () {
                                            $ionicLoading.show({
                                                template: 'Searching...'
                                            });
                                            var datadate = {
                                                from: $scope.datadate.from_date,
                                                to: $scope.datadate.to_date,
                                                user_id: $window.localStorage['uid']
                                            };
                                            tmsService.searchTimesheet(datadate).success(function (srcresp) {
                                                $scope.tmss = srcresp;
                                            }, function (err) {
                                                $ionicPopup.alert({
                                                    title: '<i class="icon ion-minus-circled"></i> ERROR',
                                                    template: err
                                                });
                                            }).finally(function () {
                                                $scope.hide();
                                                $scope.sfromdate = '';
                                                $scope.stodate = '';
                                            });
                                            console.log(datadate);
                                        }
                                    }
                                ]
                            });
                            return true;
                        } else {
                            if ($scope.timeIds.length == 0) {
                                $ionicPopup.alert({
                                    title: '<i class="icon ion-alert"></i> WARNING',
                                    template: 'Please select at least a time'
                                });
                            } else if ($scope.timeIds.length == 1) {
                                $scope.tid = $scope.timeIds[0];
                                $window.location.href = "#/formedit/" + $scope.tid;
                            } else {
                                $ionicPopup.alert({
                                    title: '<i class="icon ion-alert"></i> WARNING',
                                    template: 'Please select only a time'
                                });
                            }
                            return true;
                        }
                    },
                    destructiveButtonClicked: function () {
                        if ($scope.timeIds.length == 0) {
                            $ionicPopup.alert({
                                title: '<i class="icon ion-alert"></i> WARNING',
                                template: 'Please select at least a time'
                            });
                        } else {
                            $ionicLoading.show({
                                template: 'Deleting...'
                            });
                            var data = {
                                id: $scope.timeIds
                            };
                            tmsService.deleteTime(data).success(function (response) {
                                if (response.status == 1) {
                                    $ionicLoading.hide();
                                    $scope.removeItem();
                                } else {
                                    $ionicLoading.hide();
                                }
                            }, function (err) {
                                $ionicPopup.alert({
                                    title: '<i class="icon ion-alert"></i> ERROR',
                                    template: err
                                });
                            }).finally(function () {
                                $ionicLoading.hide();
                            });
                        }
                        return true;
                    }
                });
            };
        })
        .controller('ListDetailCtrl', function ($scope, tmsService, $stateParams, $ionicLoading) {
            $scope.show = function () {
                $ionicLoading.show({
                    template: 'Retrieve data from server...'
                });
            };
            $scope.hide = function () {
                $ionicLoading.hide();
            };
            $scope.show();
            $scope.timeId = $stateParams.timeId;
            tmsService.getIdTimesheet($scope.timeId).success(function (response) {
                $scope.tmssdetails = response;
            }).finally(function () {
                $scope.hide();
            });
            $scope.status = $stateParams.status;
            if ($scope.status === "no") {
                $scope.statusLabel = "NOT YET APPROVED";
                $scope.color = "red";
            } else {
                $scope.statusLabel = "APPROVED";
                $scope.color = "green";
            }
        })
        .controller('FormEditCtrl', function ($scope, tmsService, $stateParams, $ionicLoading, $ionicPopup, $filter, $window, $cordovaDatePicker) {
            $scope.showAllert = function (msg) {
                $ionicPopup.alert({
                    title: msg.title,
                    template: msg.message,
                    okText: 'Ok',
                    okType: 'button-positive'
                });
            };
            $scope.show = function () {
                $ionicLoading.show({
                    template: 'Retrieve data from server...'
                });
            };
            $scope.hide = function () {
                $ionicLoading.hide();
            };
            $scope.show();
            $scope.timeId = $stateParams.timeId;
            $scope.tmssdetails = [];
            tmsService.getIdTimesheet($scope.timeId).success(function (response) {
                $scope.tmssdetails = response;
                $scope.label = {
                    start_date: $filter('date')(new Date($scope.tmssdetails[0].start_time), 'dd/MM/yyyy'),
                    start_time: $filter('date')(new Date($scope.tmssdetails[0].start_time), 'HH:mm'),
                    end_date: $filter('date')(new Date($scope.tmssdetails[0].end_time), 'dd/MM/yyyy'),
                    end_time: $filter('date')(new Date($scope.tmssdetails[0].end_time), 'HH:mm')
                };
                $scope.tms = {
                    id: $scope.tmssdetails[0].id,
                    start_date: new Date($scope.tmssdetails[0].start_time),
                    start_time: new Date($scope.tmssdetails[0].start_time),
                    end_date: new Date($scope.tmssdetails[0].end_time),
                    end_time: new Date($scope.tmssdetails[0].end_time),
                    ot: $scope.tmssdetails[0].out_of_town,
                    town: $scope.tmssdetails[0].town,
                    driver_gs: $scope.tmssdetails[0].driver_gs,
                    used_for: $scope.tmssdetails[0].type_of_use
                };

            }).finally(function () {
                $scope.hide();
            });
            $scope.startDate = function () {
                var options = {
                    date: new Date($scope.tmssdetails[0].start_time),
                    mode: 'date',
                    okText: 'Set',
                    androidTheme: 5
                };
                document.addEventListener("deviceready", function () {
                    $cordovaDatePicker.show(options).then(function (date) {
                        $scope.tms.start_date = date;
                        $scope.label.start_date = $filter('date')(date, 'dd/MM/yyyy');
                    });
                }, false);
            };
            $scope.endDate = function () {
                var options = {
                    date: new Date($scope.tmssdetails[0].end_time),
                    mode: 'date',
                    okText: 'Set',
                    androidTheme: 3
                };
                document.addEventListener("deviceready", function () {
                    $cordovaDatePicker.show(options).then(function (date) {
                        $scope.tms.end_date = date;
                        $scope.label.end_date = $filter('date')(date, 'dd/MM/yyyy');
                    });
                }, false);
            };
            $scope.startTime = function () {
                var options = {
                    date: new Date(),
                    mode: 'time',
                    is24Hour: true,
                    okText: 'Set',
                    androidTheme: 3
                };
                document.addEventListener("deviceready", function () {
                    $cordovaDatePicker.show(options).then(function (date) {
                        $scope.tms.start_time = date;
                        $scope.label.start_time = $filter('date')(date, 'HH:mm');
                    });
                }, false);
            };
            $scope.endTime = function () {
                var options = {
                    date: new Date(),
                    mode: 'time',
                    is24Hour: true,
                    okText: 'Set',
                    androidTheme: 3
                };
                document.addEventListener("deviceready", function () {
                    $cordovaDatePicker.show(options).then(function (date) {
                        $scope.tms.end_time = date;
                        $scope.label.end_time = $filter('date')(date, 'HH:mm');
                    });
                }, false);
            };
            $scope.updateTimesheet = function () {
                $scope.fstart_date = $filter('date')($scope.tms.start_date, 'yyyyMMdd');
                $scope.fstart_time = $filter('date')($scope.tms.start_time, 'HHmm');
                $scope.fend_date = $filter('date')($scope.tms.end_date, 'yyyyMMdd');
                $scope.fend_time = $filter('date')($scope.tms.end_time, 'HHmm');
                $scope.fstart_datetime = $scope.fstart_date+''+$scope.fstart_time;
                $scope.fend_datetime = $scope.fend_date+''+$scope.fend_time;
                if (!$scope.tms.start_date) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Start date must not null'
                    });
                } else if (!$scope.tms.start_time) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Start time must not null'
                    });
                } else if (!$scope.tms.end_date) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'End date must not null'
                    });
                } else if (!$scope.tms.end_time) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'End time must not null'
                    });
                } else if (!$scope.tms.ot) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Please select Out of town'
                    });
                } else if (!$scope.tms.used_for) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Please select user for'
                    });
                } else if ($scope.fstart_date > $scope.fend_date) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Please check the date entered'
                    });
                } else if ($scope.fstart_date+$scope.fstart_time > $scope.fend_date+$scope.fend_time) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'Please check the time entered'
                    });
                } else if (($scope.fend_datetime - $scope.fstart_datetime) >= 10000) {
                    $scope.showAllert({
                        title: '<i class="icon ion-alert"></i> ALERT',
                        message: 'More than 24 hours isn\'t allowed'
                    });
                } else {
                    $scope.show = function () {
                        $ionicLoading.show({
                            template: 'Updating data...'
                        });
                    };
                    $scope.hide = function () {
                        $ionicLoading.hide();
                    };
                    $scope.show();
                    var data = {
                        id: $scope.timeId,
                        start_date: $scope.tms.start_date,
                        start_time: $scope.tms.start_time,
                        end_date: $scope.tms.end_date,
                        end_time: $scope.tms.end_time,
                        ot: $scope.tms.ot,
                        town: $scope.tms.town,
                        driver_gs: $scope.tms.driver_gs,
                        used_for: $scope.tms.used_for
                    };
                    tmsService.update(data).success(function (resp) {
                        $scope.showAllert({
                            title: '<i class="icon ion-checkmark-round"></i> SUCCESS',
                            message: 'Data has been successful updated'
                        });
                        $scope.start_date = "";
                        $scope.start_time = "";
                        $scope.end_date = "";
                        $scope.end_time = "";
                        $scope.ot = "";
                        $scope.town = "";
                        $scope.driver_gs = "";
                        $scope.used_for = "";
                        $window.location.href = "#/list";
                    }, function (err) {
                        $scope.showAllert({
                            title: '<i class="icon ion-minus-circled"></i> ERROR',
                            message: err
                        });
                    }).finally(function () {
                        $scope.hide();
                    });
                }
            };
        });



